



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>总结Hibernate4.1+版本与Hibernate3.3+版本区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">总结Hibernate4.1+版本与Hibernate3.3+版本区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 14:03:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>利用休假时间好好学习了当今流行的ORMapping框架-<strong>Hibernate，</strong>看完了马士兵老师经典的Hibernate视频教程，也算是小小入门了吧。</p>
<p>马老师在讲课中使用的Hibernate版本是3.3.2，而我们现在从Hibernate官网上下载的最新版本是4.2.3。</p>
<p>当然Hibernate从版本3+到4+升级过程(为了适应JPA2.0?)中还是有点些变化的，因为我是用4.2.3版本做实验的，所以下面稍微总结下区别。（欢迎批评指正）</p>
<p><strong>1.使用hibernate.properties配置文件</strong></p>
<p>以下配置的信息可以不用写在传统的hibernate.cfg.xml中了，可以写在hibernate.properties配置文件中。</p>
<div>
<pre class="prettyprint linenums">hibernate.connection.driver_class=com.mysql.jdbc.Driver<br />
hibernate.connection.url=jdbc:mysql://localhost:3306/hibernate<br />
hibernate.connection.password=root<br />
hibernate.connection.username=root<br />
hibernate.connection.pool_size=100<br />
hibernate.dialect=org.hibernate.dialect.MySQL5Dialect<br />
hibernate.show_sql=true<br />
hibernate.format_sql=true</pre>
</div>
<p>其中在3.3+版本中连接MySQL数据库只需要指明MySQLDialect即可。在4.1+版本中可以指出MySQL5Dialect。</p>
<p><strong>2.SessionFactory对象的buildSessionFactory方法</strong></p>
<p>4.1+版本中不带参数的buildSessionFactory()已经被废除，取而代之的是buildSessionFactory(ServiceRegistry ServiceRegistry)</p>
<p>为此我们采用以下方法：</p>
<div>
<pre class="prettyprint linenums">public class HibernateTest {

    private static SessionFactory sf  = null;

    @BeforeClass<br />
    public static void beforeClass(){<br />
        Configuration cfg = new Configuration().configure();<br />
        ServiceRegistryBuilder srb = new ServiceRegistryBuilder();<br />
        //默认读取hibernate.properties里面的配置信息<br />
        sf = cfg.buildSessionFactory(srb.buildServiceRegistry());<br />
    }

    @AfterClass<br />
    public static void afterClass(){<br />
        sf.close();<br />
    }</pre>
</div>
<p>这里有两点需要注意</p>
<p>　　　　　　　　1）若使用XML配置文件的方式配置实体类:需要在代码中手动加入resource文件</p>
<p>　　　　　　　　　　（在hibernate.cfg.xml中配置已经无效&lt;mapping resource="cn/ntt/china/model/Student.hbm.xml"/&gt;）</p>
<p>　　　　　　　　　　例:cfg.addResource("cn/ntt/china/model/Student.hbm.xml");//须指明全路径</p>
<p>　　　　　　　　2）若使用注解方式:与原来3.3+版本一样在需要在hibernate.cfg.xml中加入配置即可</p>
<p>　　　　　　　　　　例：&lt;mapping class="cn.ntt.china.model.Teacher"/&gt;</p>
<p>另外org.hibernate.cfg.AnnotationConfiguration;(<strong>Deprecated.</strong>&nbsp;<em>All functionality has been moved to&nbsp;<code><a href="/Java/src/hibernate-release-4.1.0.Final/documentation/javadocs/org/hibernate/cfg/Configuration.html" rel="external nofollow noreferrer">Configuration</a>)</code></em></p>
<p>这个注解读取配置的class已经废弃，现在读取配置不需要特别注明是注解。</p>
<p>为了适应JPA规范，Hibernate4.1+版本中推荐使用annotation配置。</p>
<p>所以在引进jar包时把requested里面的包全部引进来就已经包含了annotation必须包了。</p>
<p><strong>3.二级缓存配置</strong></p>
<p>原来3.3+：</p>
<div>
<pre class="prettyprint linenums">        &lt;property name="cache.use_query_cache"&gt;true&lt;/property&gt;<br />
        &lt;property name="cache.use_second_level_cache"&gt;true&lt;/property&gt;<br />
        &lt;property name="cache.provider_class"&gt;org.hibernate.cache.EhCacheProvider&lt;/property&gt;</pre>
</div>
<p>现在4.1+:</p>
<div>
<pre class="prettyprint linenums">        &lt;property name="cache.use_query_cache"&gt;true&lt;/property&gt;<br />
        &lt;property name="cache.use_second_level_cache"&gt;true&lt;/property&gt;<br />
        &lt;property name="cache.region.factory_class"&gt;org.hibernate.cache.ehcache.EhCacheRegionFactory&lt;/property&gt;</pre>
</div>
<p>Hibernate学到现在算到告一段落。现在回想下Hibernate的核心思想其实就是把数据库中表与表的关系的操作，转化封装为java对象与对象的操作！那为什么要这样做呢？</p>
<p>原因很简单这样做符合我们日常面向对象编程的习惯，并且简化持久层操作的代码。</p>
<p>sun为这个思想制定了一套规范，即JPA！可见在不久的将来Java持久化操作要被JPA统一。</p>
<p>最后感谢马老师的在视频中的精彩讲解！</p>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4957p1zq.html">Anliven - 有效阅读的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2pk1x8.html">&lbrack;CLR via C&num;&rsqb;9&period; 参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/4956nkv8.html">shell定时任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pz5kd8.html">eclipse 中的 jar file 和 runnable jar file的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zkyx09.html">How to install more voices to Windows Speech&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xww1z9.html">Canvas tutorial</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnro09.html">OSPF LSA的详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1jpxj9.html">PHP查询数据库中满足条件的记录条数&lpar;二种实现方法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydlydxq.html">jdk在windows中的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7y2lq.html">关于scanf&lpar;&amp;quot&semi;&percnt;c&amp;quot&semi;，&amp;amp&semi;ch&rpar;直接跳过的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503kjm8.html">绳关节&lpar;b2RopeJoint&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zweg39.html">django-rest-framework之请求与响应</a>
		</li>
						<li><a href="https://www.batexi.com/a/950v37m8.html">MySQL体系结构及多实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mdlzq.html">【Visual C&plus;&plus;】游戏编程学习笔记之四：透明动画实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k67r69.html">【转】简单了介绍js中的一些概念（词法结构） 和 数据类型（部分）。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdy7pv9.html">JS&lpar;JavaScript）的初了解4（更新中&amp;&num;183&semi;&amp;&num;183&semi;&amp;&num;183&semi;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25npxoq.html">CCF2014032窗口（C语言）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1rk249.html">CSS3&colon;HSL和HSLA</a>
		</li>
						<li><a href="https://www.batexi.com/a/q254y4oq.html">MongDB篇，第一章：数据库知识1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zymlyn9.html">巧用NULL模式解耦依赖</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyy0epgq.html">Ubantu 16&period;04升级内核版本和还原到升级之前的内核版本的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv275nx9.html">Visual Studio For MacOS  踩坑记&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyoydgq.html">leetcode &mdash; regular-expression-matching</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5w5drq.html">leetcode &mdash; add-two-numbers</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2565j3q.html">C语言第十一讲&comma;预处理命令&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r1rpo9.html">Netty 超时机制及心跳程序实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvlv4k8.html">go中的读写锁RWMutex</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r1dd39.html">&lbrack;HEOI2017&rsqb; 寿司餐厅 &plus; 最大权闭合子图的总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjdm5r9.html">openssl genrsa</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjd55r9.html">sql  去掉 空格</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
